## minexpert3 11.0.0

=== CMakeLists.txt ===
#############################################################
#############################################################
# CMake configuration
cmake_minimum_required(VERSION 3.18.4)

############################################################
############################################################
# Basic information about project

# Add folder where are supportive functions
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)
set(CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN32 if SYSTEM_UNAME_S is "^.*MING64.*"
# Note that WIN32 is set even on 64 bits systems.
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

# Compute the extended version number using git describe
include(${CMAKE_UTILS_PATH}/extended-version.cmake)

message("GIT_RECORD_IDENTIFIER: ${GIT_RECORD_IDENTIFIER}")

project(
    MineXpert3
    VERSION 11.0.0
    DESCRIPTION "A program to visualize and explore mass spectrometric data"
    HOMEPAGE_URL "http://wwww.msxpertsuite.org/minexpert3"
)

set(LOWCASE_PROJECT_NAME minexpert3)
set(LOWCASE_PROJECT_NAME_NO_VER minexpert)

set(TARGET ${PROJECT_NAME})

# project(VERSION) above sets: PROJECT_VERSION, <PROJECT-NAME>_VERSION
# PROJECT_VERSION_MAJOR, <PROJECT-NAME>_VERSION_MAJOR PROJECT_VERSION_MINOR,
# <PROJECT-NAME>_VERSION_MINOR PROJECT_VERSION_PATCH,
# <PROJECT-NAME>_VERSION_PATCH

# Set additional project information
set(COMPANY "MsXpertSuite.org")
set(COPYRIGHT "Copyright (c) 2016-2025 Filippo Rusconi. Licensed under GPLv3+")
set(IDENTIFIER "org.msxpertsuite")

#############################################################
#############################################################
# Installation prefix (these lines before include(GNUInstallDirs))
if(NOT CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX /usr/local)
endif()

include(GNUInstallDirs)

message(STATUS: CMAKE_CXX_LIBRARY_ARCHITECTURE is: ${CMAKE_CXX_LIBRARY_ARCHITECTURE})

set(HOME_DEVEL_DIR $ENV{HOME}/devel)

# Our build scripts take for granted that this files is available.
configure_file(${CMAKE_UTILS_PATH}/version.cmake.in ${CMAKE_BINARY_DIR}/version.txt)

# This include must come before all the others
# It must include the config-generated config.h file
# before the others.
include_directories(${CMAKE_BINARY_DIR})

# And now the source directory contains the .h|.hpp files for its .cpp files.
include_directories(${CMAKE_SOURCE_DIR})

# For the config.h file.
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("\n${BoldGreen}Configuring build for project ${CMAKE_PROJECT_NAME}${ColourReset}\n")

# This export will allow using the flags to be used by
# youcompleteme (vim plugin) and by the Clang-based code analyzer.
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json")
    execute_process(
        COMMAND cmake -E copy_if_different ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
                ${CMAKE_SOURCE_DIR}/compile_commands.json
    )
endif()

# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
# We do not want warnings for unknown pragmas:
message(STATUS "Setting definition -Wno-unknown-pragmas.")
add_definitions(-Wno-unknown-pragmas)

# Enable warnings and possibly treat them as errors
message(STATUS "Setting definition -Wall -pedantic.")
add_definitions(-Wall -pedantic)
message(STATUS "Setting definition -Wextra.")
add_definitions(-Wextra)

if(WARN_AS_ERROR)
    message(STATUS "Setting definition -Werror.")
    add_definitions(-Werror)
endif()

message("CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}")

option(MXE "Use the cross-compiling environment MXE" OFF)

option(PAPPSO_LOCAL_DEV "Use locally developped libpappsomspp" OFF)
option(PAPPSO_LOCAL_INST "Use /usr/local/lib installed libpappsomspp" OFF)

if(PAPPSO_LOCAL_DEV AND PAPPSO_LOCAL_INST)
    message(FATAL_ERROR "Cannot have both PAPPSO_LOCAL_DEV and PAPPSO_LOCAL_INST")
endif()

message(STATUS "PAPPSO_LOCAL_DEV: ${PAPPSO_LOCAL_DEV}")
message(STATUS "PAPPSO_LOCAL_INST: ${PAPPSO_LOCAL_INST}")

option(XPERTMASS_LOCAL_DEV "Use locally developped libXpertMass" OFF)
option(XPERTMASS_LOCAL_INST "Use /usr/local/lib installed libXpertMass" OFF)

if(XPERTMASS_LOCAL_DEV AND XPERTMASS_LOCAL_INST)
    message(FATAL_ERROR "Cannot have both XPERTMASS_LOCAL_DEV and XPERTMASS_LOCAL_INST")
endif()

message(STATUS "XPERTMASS_LOCAL_DEV: ${XPERTMASS_LOCAL_DEV}")
message(STATUS "XPERTMASS_LOCAL_INST: ${XPERTMASS_LOCAL_INST}")

option(PROFILING Off)
if(PROFILING)
    message(STATUS "${BoldYellow}Profiling is requested, adding -pg -g flags.${ColourReset}")
    add_definitions(-pg -g)
endif()

#############################################################
#############################################################
# Platform-specific CMake configuration
if(WIN32 OR _WIN32)

    if(MXE)

        # Run the following cmake command line:
        # x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development
        include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)

        # Set the name to the systemUname variable because in this situation that name
        # is not found, it it passed as a flag in the command line.
        set(SYSTEM_UNAME_S "mxe")

    elseif(WIN10UCRT64)
        include(${CMAKE_TOOLCHAINS_PATH}/win10-ucrt64-toolchain.cmake)
    endif()

elseif(UNIX)

    message("UNIX toolchain being selected")

    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-common.cmake)

endif()

# Define this as On if JavaScript/Qml bindings are to be exported.
# See src/CMakeLists.txt
# See #cmakedefine in CMakeStuff/config.h.cmake.in
# Need to #inlude "config.h" for the defined value to be visible.
# option(JS_QML "Generate the JavaScript/Qml bindings plugin lib" Off)

message("")
message(STATUS "${BoldGreen}Starting configuration of ${CMAKE_PROJECT_NAME}${ColourReset}")
message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SYSTEM_UNAME_S}${ColourReset}")
message("")

#############################################################
#############################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE
        Release
        CACHE STRING "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel." FORCE
    )
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
    message(STATUS "Compiling in release mode.")
    add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
    message(STATUS "Compiling in debug mode.")
    message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
    add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
    message(STATUS "Compiling in release with debug info mode.")
endif()

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")

if(PROFILE)
    message(STATUS "${BoldYellow}Profiling is requested, adding -pg flag.${ColourReset}")
    add_definitions(-pg)
endif()

message(STATUS "${BoldYellow}Main CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

# It is essential to run these config steps before delving into the minexpert
# directory, because at that moment they will need what are
# going to prepare right now.
configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/splashscreen.svg.in ${CMAKE_SOURCE_DIR}/images/svg/splashscreen.svg @ONLY)

# Make the conversion of the svg file into a png, but only on GNU/Linux
if(UNIX)
    execute_process(
        COMMAND rsvg-convert -f png -o ${CMAKE_SOURCE_DIR}/images/splashscreen.png
                ${CMAKE_SOURCE_DIR}/images/svg/splashscreen.svg
    )
endif()

#############################################################
######################
# BUILD OF THE PROGRAM

message(STATUS "Adding subdirectory src for TARGET: ${TARGET}")
add_subdirectory(src)

#############################################################
################################
# BUILD OF THE DOC / USER MANUAL
option(BUILD_USER_MANUAL "Build the user manual, on UNIX only." OFF)
message(STATUS "Adding subdirectory doc for project: ${TARGET}")
add_subdirectory(doc)

# Use all the configured paths to create the config.h file.
# The config file is binary directory-specific !!!
configure_file(${CMAKE_UTILS_PATH}/config.h.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/src/config.h @ONLY)

####################################################
# Installation directories depending on the platform
####################################################

# See the CMakeStuff/toolchains platform-specific files.
message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "PROJECT_INSTALL_BIN_DIR: ${PROJECT_INSTALL_BIN_DIR}")
message(STATUS "PROJECT_INSTALL_LIB_DIR: ${PROJECT_INSTALL_LIB_DIR}")
message(STATUS "PROJECT_INSTALL_LIB_QML_DIR: ${PROJECT_INSTALL_LIB_QML_DIR}")
message(STATUS "PROJECT_INSTALL_DATA_DIR: ${PROJECT_INSTALL_DATA_DIR}")
message(STATUS "PROJECT_INSTALL_DOC_DIR: ${PROJECT_INSTALL_DOC_DIR}")

#############################################################
###########################
# CREATE THE SOURCE PACKAGE
include(${CMAKE_UTILS_PATH}/targz-source-package-creation.cmake)

add_custom_target(
    archive
    cpack
    -G
    TGZ
    --config
    CPackSourceConfig.cmake
    &&
    mv
    ${CMAKE_BINARY_DIR}/${LOWCASE_PROJECT_NAME}-${PROJECT_VERSION}.tar.gz
    ${CMAKE_SOURCE_DIR}/../tarballs
    &&
    ln
    -sf
    ${CMAKE_SOURCE_DIR}/../tarballs/${LOWCASE_PROJECT_NAME}-${PROJECT_VERSION}.tar.gz
    ${CMAKE_SOURCE_DIR}/../${LOWCASE_PROJECT_NAME}_${PROJECT_VERSION}.orig.tar.gz
    &&
    ln
    -sf
    ${CMAKE_SOURCE_DIR}/../tarballs/${LOWCASE_PROJECT_NAME}-${PROJECT_VERSION}.tar.gz
    ${CMAKE_SOURCE_DIR}/../tarballs/${LOWCASE_PROJECT_NAME}_${PROJECT_VERSION}.orig.tar.gz
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Creating .tar.gz"
    VERBATIM
)

#############################################################
# summary
message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldRed}   General configuration of the ${CMAKE_PROJECT_NAME} project ${ColourReset}")
message("")

message(STATUS "${BoldYellow}System is detected by CMake as ${SYSTEM_UNAME_S}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_STANDARD: ${CMAKE_CXX_STANDARD}${ColourReset}")

message("")

message(STATUS "${BoldYellow}CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}${ColourReset}")
message(STATUS "${BoldYellow}TARGET: ${TARGET}${ColourReset}")
message(STATUS "${BoldYellow}Installation BIN directory: ${PROJECT_INSTALL_BIN_DIR}${ColourReset}")
message(STATUS "${BoldYellow}Installation LIB directory: ${PROJECT_INSTALL_LIB_DIR}${ColourReset}")
message(STATUS "${BoldYellow}Installation LIB QML directory: ${PROJECT_INSTALL_LIB_QML_DIR}${ColourReset}")
message(STATUS "${BoldYellow}Installation DATA directory: ${PROJECT_INSTALL_DATA_DIR}${ColourReset}")
message(STATUS "${BoldYellow}Installation DOC directory: ${PROJECT_INSTALL_DOC_DIR}${ColourReset}")

if(PROFILING)
    message(STATUS "${BoldYellow}Profiling is requested (-DPROFILING=1)${ColourReset}")
else()
    message(STATUS "${BoldYellow}Profiling is NOT requested (-DPROFILING=0)${ColourReset}")
endif()

if(WARNASERR)
    message(STATUS "${BoldYellow}Warnings ARE treated as errors (-DWARNASERR=1)${ColourReset}")
else()

=== doc/CMakeLists.txt ===
message("")
message(STATUS "${BoldGreen}Starting configuration for the doc material for ${CMAKE_PROJECT_NAME} ${ColourReset}")
message("")

# The UNIX man pages
if(UNIX AND NOT APPLE)

  message("\n${BoldYellow}Generating the man page.${ColourReset}\n")

	execute_process(COMMAND docbook-to-man ${PROJECT_NAME}.xml
		OUTPUT_FILE	${CMAKE_BINARY_DIR}/${PROJECT_NAME}.1
		WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

endif()


###############
# install stuff

# The history and licence files.

message("\n${BoldGreen}Installation directory for the doc files:
${PROJECT_INSTALL_DOC_DIR}${ColourReset}\n")

install(FILES history.html ../LICENSE
	DESTINATION ${PROJECT_INSTALL_DOC_DIR})

# The man page.
if(UNIX AND NOT APPLE)
	install(FILES ${CMAKE_BINARY_DIR}/${PROJECT_NAME}.1
		DESTINATION ${CMAKE_INSTALL_DATADIR}/man/man1)
endif()


#############################################################
###########################
# BUILD OF THE USER MANUAL

# The version of the program needs to be set in the user manual front
# matter. We need to make this configuration even if we do not build the
# user manual because when building debian packages the source tarball
# needs to have the right version in the file.
configure_file(
    ${CMAKE_SOURCE_DIR}/CMakeStuff/user-manual-version-entity.ent.cmake.in
    ${CMAKE_SOURCE_DIR}/doc/user-manual/xml/user-manual-version-entity.ent @ONLY
)

if(UNIX AND BUILD_USER_MANUAL)
	add_subdirectory(user-manual)
endif()

message("\n${BoldGreen}Ending configuration for subdirectory doc${ColourReset}\n")

=== src/CMakeLists.txt ===
message("\n${BoldRed}Now configuring src/js_qml for ${TARGET}${ColourReset}\n")

set(NONGUI_DIR ${CMAKE_CURRENT_SOURCE_DIR}/nongui)
set(GUI_DIR ${CMAKE_CURRENT_SOURCE_DIR}/gui)

########################################################
# Files
set(${TARGET}_nongui_SRCS
    #
    # The classes that handle the processing flow
    ${NONGUI_DIR}/ProcessingFlow.cpp
    ${NONGUI_DIR}/ProcessingStep.cpp
    ${NONGUI_DIR}/ProcessingType.cpp
    #
    # Some globals.
    ${NONGUI_DIR}/globals.cpp
    #
    # The classes to look into an MS run prior to loading it
    ${NONGUI_DIR}/MsRunProber.cpp
    ${NONGUI_DIR}/vendor/BrukerTimsTofMsRunProber.cpp
    #
    # The main class that hold the mass data.
    ${NONGUI_DIR}/MsRunDataSet.cpp
    #
    # The class to handle the statistics computation about a given MsRunDataSet.
    ${NONGUI_DIR}/MsRunDataSetStats.cpp
    #
    # The class to load MS run data
    ${NONGUI_DIR}/MassSpecDataFileLoader.cpp
    ${NONGUI_DIR}/MassSpecDataFileLoaderToVector.cpp
    #
    # The base class of the integrators.
    ${NONGUI_DIR}/MassDataIntegrator.cpp
    #
    # The various integrators that use BaseMsRunDataSetTreeNodeVisitor.
    ${NONGUI_DIR}/MsRunDataSetTreeMassDataIntegratorToRt.cpp
    #
    # The classe that monitors integrators.
    ${NONGUI_DIR}/MassDataIntegratorTask.cpp
    #
    # The various MsRunDataSetTreeNodeVisitor classes.
    ${NONGUI_DIR}/BaseMsRunDataSetTreeNodeVisitor.cpp
    ${NONGUI_DIR}/MsRunStatisticsTreeNodeVisitor.cpp
    ${NONGUI_DIR}/MultiTreeNodeCombinerVisitor.cpp
    ${NONGUI_DIR}/TicChromTreeNodeCombinerVisitor.cpp
    ${NONGUI_DIR}/TicChromatogramFromMassSpecDataFile.cpp
    # #
    # # The various integrators that use QualifiedMassSpectrumVector.
    ${NONGUI_DIR}/QualifiedMassSpectrumVectorMassDataIntegrator.cpp
    ${NONGUI_DIR}/QualifiedMassSpectrumVectorMassDataIntegratorToRt.cpp
    ${NONGUI_DIR}/QualifiedMassSpectrumVectorMassDataIntegratorToMz.cpp
    ${NONGUI_DIR}/QualifiedMassSpectrumVectorMassDataIntegratorToDt.cpp
    ${NONGUI_DIR}/QualifiedMassSpectrumVectorMassDataIntegratorToTicInt.cpp
    ${NONGUI_DIR}/QualifiedMassSpectrumVectorMassDataIntegratorToDtRtMz.cpp
    ${NONGUI_DIR}/QualifiedMassSpectrumVectorMassDataIntegratorToRtDt.cpp
    # #
    # # The classes that handle the parameters for the various integrations and the
    # # display of traces.
    ${NONGUI_DIR}/MsFragmentationSpec.cpp
    # #
    # # Discoveries preferences
    ${NONGUI_DIR}/DiscoveriesPreferences.cpp
)

set(${TARGET}_gui_SRCS
    #
    ${GUI_DIR}/AboutDlg.cpp
    ${GUI_DIR}/Application.cpp
    ${GUI_DIR}/ApplicationPreferencesWnd.cpp
    ${GUI_DIR}/ProgramWindow.cpp
    #
    ${GUI_DIR}/MsRunLoader.cpp
    ${GUI_DIR}/ConsoleWnd.cpp
    #
    ${GUI_DIR}/vendor/BrukerTimsTofMsRunLoader.cpp
    ${GUI_DIR}/vendor/BrukerBafAsciiMsRunLoader.cpp
    ${GUI_DIR}/vendor/PwizLiteMsRunLoader.cpp
    ${GUI_DIR}/vendor/MzCborMsRunLoader.cpp
    ${GUI_DIR}/XyMsRunLoader.cpp
    ${GUI_DIR}/MsRunReadTask.cpp
    ${GUI_DIR}/MsRunProbeTask.cpp
    # #
    ${GUI_DIR}/OpenMsRunDataSetsDlg.cpp
    #
    ${GUI_DIR}/TaskMonitorCompositeWidget.cpp
    ${GUI_DIR}/TaskMonitorWnd.cpp
    #
    ${GUI_DIR}/MsRunProbeInfoViewerDlg.cpp
    ${GUI_DIR}/MsRunSelectorDlg.cpp
    #
    # The ms run data set tree view classes
    ${GUI_DIR}/MsRunDataSetTableViewWnd.cpp
    ${GUI_DIR}/MsRunDataSetTableViewItem.cpp
    ${GUI_DIR}/MsRunDataSetTableView.cpp
    ${GUI_DIR}/MsRunDataSetTableViewModel.cpp
    ${GUI_DIR}/MsRunDataSetTableViewProxyModel.cpp
    #
    # The MS fragmentation specification dialog
    ${GUI_DIR}/MsFragmentationSpecDlg.cpp
    #
    # The M/Z integration parameters dialog
    ${GUI_DIR}/MzIntegrationParamsDlg.cpp
    #
    # The Savitzky-Golay filter params dialog
    ${GUI_DIR}/SavitzkyGolayFilterParamsDlg.cpp
    #
    # The data plot graph/widget tree classes
    ${GUI_DIR}/DataPlottableNode.cpp
    ${GUI_DIR}/DataPlottableTree.cpp
    #
    # The trace plot composite widgets
    ${GUI_DIR}/BasePlotCompositeWidget.cpp
    ${GUI_DIR}/BaseTracePlotCompositeWidget.cpp
    ${GUI_DIR}/TicXicChromTracePlotCompositeWidget.cpp
    ${GUI_DIR}/MassSpecTracePlotCompositeWidget.cpp
    ${GUI_DIR}/DriftSpecTracePlotCompositeWidget.cpp
    #
    # The color map plot composite widgets
    ${GUI_DIR}/BaseColorMapPlotCompositeWidget.cpp
    ${GUI_DIR}/TicXicChromMassSpecColorMapPlotCompositeWidget.cpp
    ${GUI_DIR}/TicXicChromDriftSpecColorMapPlotCompositeWidget.cpp
    ${GUI_DIR}/DriftSpecMassSpecColorMapPlotCompositeWidget.cpp
    #
    # The plot windows
    ${GUI_DIR}/BasePlotWnd.cpp
    #
    # Trace plot windows
    ${GUI_DIR}/BaseTracePlotWnd.cpp
    ${GUI_DIR}/BaseColorMapPlotWnd.cpp
    ${GUI_DIR}/TicXicChromTracePlotWnd.cpp
    ${GUI_DIR}/MassSpecTracePlotWnd.cpp
    ${GUI_DIR}/DriftSpecTracePlotWnd.cpp
    #
    # Color map plot windows
    ${GUI_DIR}/TicXicChromMassSpecColorMapWnd.cpp
    ${GUI_DIR}/TicXicChromDriftSpecColorMapWnd.cpp
    ${GUI_DIR}/DriftSpecMassSpecColorMapWnd.cpp
    #
    # The save plot to graphics file
    ${GUI_DIR}/SaveToGraphicsFileDlg.cpp
    #
    # The ProcessingFlow viewer dialog window
    ${GUI_DIR}/ProcessingFlowViewerDlg.cpp
    #
    # The XIC chromatogram feature
    ${GUI_DIR}/XicExtractionWnd.cpp
    #
    # Analysis preferences
    ${GUI_DIR}/DiscoveriesPreferencesDlg.cpp
    #
    # Plot overlay transparent widget and vertical rule slider
    ${GUI_DIR}/PlotAreaOverlay.cpp
    ${GUI_DIR}/VerticalRuleSlider.cpp
)

set(${TARGET}_UIS
    ${GUI_DIR}/ui/AboutDlg.ui
    ${GUI_DIR}/ui/MsRunSelectorDlg.ui
    ${GUI_DIR}/ui/OpenMsRunDataSetsDlg.ui
    ${GUI_DIR}/ui/MsRunDataSetTableViewWnd.ui
    ${GUI_DIR}/ui/BasePlotWnd.ui
    ${GUI_DIR}/ui/BasePlotCompositeWidget.ui
    ${GUI_DIR}/ui/TaskMonitorCompositeWidget.ui
    ${GUI_DIR}/ui/TaskMonitorWnd.ui
    ${GUI_DIR}/ui/ConsoleWnd.ui
    ${GUI_DIR}/ui/MsFragmentationSpecDlg.ui
    ${GUI_DIR}/ui/MzIntegrationParamsDlg.ui
    ${GUI_DIR}/ui/SavitzkyGolayFilterParamsDlg.ui
    ${GUI_DIR}/ui/SaveToGraphicsFileDlg.ui
    ${GUI_DIR}/ui/ProcessingFlowViewerDlg.ui
    ${GUI_DIR}/ui/XicExtractionWnd.ui
    ${GUI_DIR}/ui/DiscoveriesPreferencesDlg.ui
    ${GUI_DIR}/ui/MsRunProbeInfoViewerDlg.ui
    ${GUI_DIR}/ui/ApplicationPreferencesWnd.ui
    ${GUI_DIR}/ui/ApplicationPreferencesWndGeneralPageWidget.ui
    ${GUI_DIR}/ui/ApplicationPreferencesWndDiscoveriesPageWidget.ui
    ${GUI_DIR}/ui/DecimalPlacesPreferencesWidget.ui
    ${GUI_DIR}/ui/MaxThreadCountPreferencesWidget.ui
)

set(CMAKE_AUTOUIC_SEARCH_PATHS ${GUI_DIR}/ui)

qt_standard_project_setup(REQUIRES 6.5)

qt6_add_resources(${TARGET}_qrc_CPP ../${TARGET}.qrc)

# if(JS_QML)
#
#     find_package(Qt6 REQUIRED COMPONENTS Quick)
#
#     # If we want scripting, the libPappsoMSplugin.so shared lib
#     # must be found.
#
#     #find_package(PappsoMS REQUIRED COMPONENTS PappsoMS)
#     find_package(PappsoMS REQUIRED)
#
#     if(NOT PappsoMS_FOUND)
#         message(FATAL_ERROR "PappsoMS plugin lib not found.")
#     endif()
#
#     get_target_property(PappsoMS_IMPORTED_CONFIGS PappsoMS::PappsoMS IMPORTED_CONFIGURATIONS)
#     message(STATUS "Available configurations: ${PappsoMS_IMPORTED_CONFIGS}")
#
#     get_target_property(PappsoMS_IMPORTED_LOCATION_DEBUG PappsoMS::PappsoMS IMPORTED_LOCATION_DEBUG)
#     message(STATUS "Debug PappsoMS::PappsoMS location: ${PappsoMS_IMPORTED_LOCATION_DEBUG}")
#
#     get_target_property(PappsoMS_IMPORTED_LOCATION_RELEASE PappsoMS::PappsoMS IMPORTED_LOCATION_RELEASE)
#     message(STATUS "Release PappsoMS::PappsoMS location: ${PappsoMS_IMPORTED_LOCATION_RELEASE}")
#
#     # Check current build type
#     string(TOUPPER "${CMAKE_BUILD_TYPE}" CURRENT_BUILD_TYPE_UPPER)
#     message(STATUS "Current build type: ${CURRENT_BUILD_TYPE_UPPER}")
#
#     # Like this: /usr/local/lib/qml/PappsoMS/libPappsoMSplugin.so
#     get_target_property(PappsoMS_ACTIVE_PATH PappsoMS::PappsoMS IMPORTED_LOCATION_${CURRENT_BUILD_TYPE_UPPER})
#     if(NOT PappsoMS_ACTIVE_PATH)
#         get_target_property(PappsoMS_ACTIVE_PATH PappsoMS::PappsoMS IMPORTED_LOCATION)
#     endif()
#     message(STATUS "Active library path: ${PappsoMS_ACTIVE_PATH}")
#
#     # Like this: /usr/local/lib/qml/PappsoMS
#     get_filename_component(PappsoMS_ACTIVE_DIR_PATH "${PappsoMS_ACTIVE_PATH}" DIRECTORY)
#     message(STATUS "PappsoMS_ACTIVE_DIR_PATH: ${PappsoMS_ACTIVE_DIR_PATH}")
#
#     set_property(GLOBAL PROPERTY PappsoMS_ACTIVE_DIR_PATH ${PappsoMS_ACTIVE_DIR_PATH})
#
#     get_target_property(PappsoMS_INCLUDE_DIRS PappsoMS::PappsoMS INTERFACE_INCLUDE_DIRECTORIES)
#     message(STATUS "PappsoMS_INCLUDE_DIRS: ${PappsoMS_INCLUDE_DIRS}")
#
#     # Also, add some scripting-specific stuff from this project.
#     add_subdirectory(js_qml)
#
#     set(JS_QML_DEPENDENCIES PRIVATE Qt6::Quick PappsoMS::PappsoMS ${TARGET}_qml)
#
#     qt6_add_resources(${TARGET}_qrc_CPP js_qml/${TARGET}_js_qml.qrc)
#
# endif()

###############################################################
# Configuration of the binary to be built
###############################################################

message(STATUS "CMAKE_CURRENT_SOURCE_DIR: ${CMAKE_CURRENT_SOURCE_DIR}")

include_directories(
    # The config file is binary directory-specific !!!
    # For the config.h file generated from config.h.cmake.in
    # For the ui_Xyyyyy.h files
    ${CMAKE_CURRENT_BINARY_DIR}
    # The omp.h include directory as crafted by looking into the
    # libraries' paths after find_package(OpenMP). See CMake code
    # in the main CMakeLists.txt file.
    ${OpenMP_CXX_INCLUDE_DIRS}
    # For all the source subdirectories
    ${NONGUI_DIR}
    ${GUI_DIR}
)

if(WIN32 OR _WIN32)

    qt_add_executable(
        ${TARGET}
        WIN32
        main.cpp
        ${${TARGET}_nongui_SRCS}
        ${${TARGET}_gui_SRCS}
        ${${TARGET}_UIS}
        ${${TARGET}_qrc_CPP}
        ${PLATFORM_SPECIFIC_SOURCES}
        #${CMAKE_SOURCE_DIR}/${PROJECT_NAME}.rc
    )
    # Required for Windows 10/11.
    # Well, this is what I thought. In fact, the program would not run on Win11
    # not because the linker options below were not set, but because the Win11
    # system what a family edition. I know the software runs with the stuff below
    # on Win11 pro system right.
    # FURTHER, since I have added the linker options below the program does
    # not start anymore on Win11 pro machines with infamous error:
    # 0xc000007b. Removing the lines below make MassXpert3 run on Win11 pro
    # again.
    # target_link_options(${TARGET} PRIVATE
    #     # Set OS version to Windows 10
    #     "-Wl,--major-os-version=10"
    #     "-Wl,--minor-os-version=0"
    #     # Set subsystem version
    #     "-Wl,--major-subsystem-version=10"
    #     "-Wl,--minor-subsystem-version=0"
    #     # Ensure modern subsystem
    #     "-Wl,--subsystem,windows:10.0"
    # )

    # In Debug mode we want the console to be opened so that we can read the debug
    # messages. But in Release mode the console is not desirable (the snippet
    # below removes it).
    if(CMAKE_BUILD_TYPE STREQUAL "Release")
        set_property(TARGET ${TARGET} PROPERTY WIN32_EXECUTABLE true)
    endif()

elseif(UNIX)

    qt_add_executable(
        ${TARGET}
        main.cpp
        ${${TARGET}_nongui_SRCS}
        ${${TARGET}_gui_SRCS}
        ${${TARGET}_UIS}
        ${${TARGET}_qrc_CPP}
        ${PLATFORM_SPECIFIC_SOURCES}
        gui/VerticalRuleSlider.hpp
        gui/VerticalRuleSlider.cpp
    )

endif()

# Finally actually set the linking dependencies to the executable.
# Note that there are so many cross-dependencies that it is virtually unfeasible
# to actually link the binary without resorting to the linker dance steps below.

# Still, I discovered that the order below is good with respect of the symbols
# dependencies resolutions when linking

# The general idea is to first list the libraries that *use* symbols and later
# libraries that *provide* symbols. Which is why all the Qt libs are listed at

=== src/js_qml/CMakeLists.txt ===
message("\n${BoldRed}Now configuring src/js_qml for ${TARGET}${ColourReset}\n")


########################################################
# Files
set(${TARGET}_js_qml_cpp_SRCS

    ellipse.cpp
)

set(${TARGET}_qml_SRCS

qml/Main.qml
qml/test.qml
qml/test_datapoint.qml
qml/test_mzintegrationparams.qml
)

qt6_add_resources(${TARGET}_js_qml_qrc_CPP ${TARGET}_js_qml.qrc)

qt_add_qml_module(
    ${TARGET}_qml
    URI
    ${TARGET}
    VERSION
    1.0
    # QML_FILES
    # ${${TARGET}_qml_SRCS}
    SOURCES
    ${${TARGET}_js_qml_cpp_SRCS}
    ${${TARGET}_js_qml_qrc_CPP}
    DEPENDENCIES
    QtQuick
    PappsoMS::PappsoMS
    OUTPUT_DIRECTORY
    "${CMAKE_BINARY_DIR}/qml/${TARGET}"
    NO_PLUGIN
)

target_link_libraries(
    ${TARGET}_qml
    PRIVATE Qt6::Core Qt6::Gui Qt6::Quick PappsoMS::PappsoMS
)

# Only now can we add the executable, because we have defined the sources of the
# object library above.

install(
    DIRECTORY ${CMAKE_BINARY_DIR}/qml/${TARGET}
    DESTINATION ${PROJECT_INSTALL_LIB_QML_DIR}
)

=== debian/changelog ===
minexpert3 (11.0.0-1) unstable; urgency=low

  * New release with entirely new Application preferences configuration
    system.

  * Implemented new vertical rule across plot widgets feature that shows the
    x-axis value when the plots are locked in the x-axis direction.

  * Updates to the user manual.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 12 Jan 2026 16:25:16 +0100

minexpert3 (10.3.0-1) unstable; urgency=low

  * New release with reworked QSettings-based configuration and an
    implementation of the 'Recent files... ' menu.

  * Implemented the new mzCbor loader, after new code in libpappsomspp.

  * Reworked, with new code in libpappsomspp, the code on the
    mass spectral combinations. In particular, reinstated the
    data-based binning strategy.

  * Added a new filter to remove all
    the 0-intensity data points from a trace plotted in a plot widget.

  * Depends on more recent libpappsomspp and libxpertmass.

  * Reworked the user manual documentation about the binning strategy.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 18 Dec 2025 20:01:15 +0100

minexpert3 (10.2.0-1) unstable; urgency=low

  * New release with reworked deconvolution processes to always compute
    the mass of the analyte under the mass peak at the start of the mouse
    drag movement.

  * Update to the user manual.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 29 Nov 2025 14:38:10 +0100

minexpert3 (10.1.1-1) unstable; urgency=low

  * New release with improved data analysis configuration.

  * Update to the user manual.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 22 Nov 2025 00:40:31 +0100

minexpert3 (10.1.0-1) UNRELEASED; urgency=low

  * New release fixing the versioning in the user manual
    user-manual-version-entity.ent file.

  * Updated the user manual with a new section about scripting.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 30 Oct 2025 20:30:36 +0100

minexpert3 (10.0.0-1) UNRELEASED; urgency=low

  * New version of the project ported to the new libXpertMass/libXpertMassGui
    libraries.

 -- Filippo Rusconi <lopippo@debian.org>  Sun, 01 Jun 2025 21:30:05 +0200

=== debian/control ===
Source: minexpert3
Section: science
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper-compat (= 13),
 dpkg-dev (>= 1.21.22),
# To export from svg to png
 librsvg2-bin,
 libgomp1,
 qt6-base-dev,
 qt6-declarative-dev,
 libqt6svg6-dev,
 libqt6core5compat6-dev,
 libxkbcommon-x11-dev,
 cmake,
 daps,
 libjs-jquery,
 libjs-highlight.js,
 texlive-fonts-extra,
 fonts-ebgaramond-extra,
 fonts-urw-base35,
# Only the logically essential one.
 libpappsomspp-gui-dev (>= 0.11.9),
# Only the logically essential one.
 libxpertmassgui-dev (>= 1.7.1),
 libqscintilla2-qt6-dev,
 libisospec++-dev (>=2.3.1),
 libpwizlite-dev,
 libsqlite3-dev,
 libzstd-dev,
 liblzf-dev,
 zlib1g-dev,
 libquazip1-qt6-dev,
 libqcustomplot-dev (>= 2.1.0),
 libodsstream-dev (>= 0.9.14),
 libboost1.88-dev,
 libboost-thread1.88-dev,
 libboost-system1.88-dev,
 libboost-filesystem1.88-dev,
 libboost-iostreams1.88-dev,
 libboost-chrono1.88-dev,
 libboost-random1.88-dev,
 libboost-container1.88-dev,
 docbook-xml,
 docbook-to-man
Standards-Version: 4.7.2
Homepage: http://www.msxpertsuite.org/
Vcs-Browser: https://salsa.debian.org/debichem-team/minexpert3
Vcs-Git: https://salsa.debian.org/debichem-team/minexpert3.git
Rules-Requires-Root: no

Package: minexpert2
Depends: minexpert3,
         ${misc:Depends},
Architecture: all
Section: oldlibs
Description: transitional package for minexpert2 -> minexpert3
 This is a transitional package. It can safely be removed.
 Runtime package.

Package: minexpert2-doc
Depends: minexpert3-doc,
         ${misc:Depends},
Architecture: all
Section: oldlibs
Description: transitional package for minexpert2-doc -> minexpert3-doc
 This is a transitional package. It can safely be removed.
 Documentation package.

Package: minexpert3
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Suggests: minexpert3-doc (>= ${source:Upstream-Version})
Replaces: minexpert, minexpert2
Breaks: minexpert, minexpert
Description: MS^n mass spectrometric data visualization and mining (runtime)
 MineXpert3 allows the user to perform the following tasks:
  - Open mass spectrometry data files (mzML, mzXML, asc, xy, ...);
  - Display in a table view the full data set, for easy filtering;
  - Calculate and display the TIC chromatogram;
  - Calculate and display a mz=f(rt) color map;
  - For mobility data, calculate and display a mz=f(dt) color map;
  - Integrate the mass spectrometric data from any kind of data
    representation (mass | drift spectra, TIC | XIC chromatogram,
    2D color maps) to any other kind of data representation;
  - For any mass data feature (mass peak, TIC | XIC peak, color map)
    integrate to a XIC single intensity value;
  - Powerful isotopic cluster calculation starting from a
    chemical formula, optionally with user-defined isotopic abundance ratios;
  - Gaussian fit over any isotopic cluster to estimate the
    average mass of a given ion;
  - Mouse-driven deconvolution of m/z data (charge envelope-based
    or isotopic cluster-based);
  - Export the data to text files;
  - Export the graphical representation of mass spectrometric
    data to graphics files in a number of formats (jpg, png, pdf).
 .
 This package ships the MineXpert3 program.


Package: minexpert3-doc
Section: doc
Architecture: all
Depends: libjs-jquery,
         libjs-highlight.js,
         ${misc:Depends}
Replaces: minexpert2-doc
Breaks: minexpert2-doc
Description: MS^n mass spectrometric data visualization and mining (doc)
 MineXpert3 allows the user to perform the following tasks:
  - Open mass spectrometry data files (mzML, mzXML, asc, xy, ...);
  - Display in a table view the full data set, for easy filtering;
  - Calculate and display the TIC chromatogram;
  - Calculate and display a mz=f(rt) color map;
  - For mobility data, calculate and display a mz=f(dt) color map;
  - Integrate the mass spectrometric data from any kind of data
    representation (mass | drift spectra, TIC | XIC chromatogram,
    2D color maps) to any other kind of data representation;
  - For any mass data feature (mass peak, TIC | XIC peak, color map)
    integrate to a XIC single intensity value;
  - Powerful isotopic cluster calculation starting from a
    chemical formula, optionally with user-defined isotopic abundance ratios;
  - Gaussian fit over any isotopic cluster to estimate the
    average mass of a given ion;
  - Mouse-driven deconvolution of m/z data (charge envelope-based
    or isotopic cluster-based);
  - Export the data to text files;
  - Export the graphical representation of mass spectrometric
    data to graphics files in a number of formats (jpg, png, pdf).
 .
 This package ships the user manual in both PDF and HTML formats.

=== debian/rules ===
#!/usr/bin/make -f
# Based on the initial work of Joey Hess and Craig Small.

# Include for DEB_VERSION_UPSTREAM below
include /usr/share/dpkg/pkg-info.mk

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

# Set path to this directory so that our tweaked fop script is used.
PATH := $(CURDIR)/doc/user-manual/scripts:$(PATH)
$(info PATH: $(PATH))


%:
	dh $@

# Required to stop it from calling my convenience Makefile that is only used for
# my day-to-day work.
override_dh_auto_clean:

override_dh_clean:
	dh_clean
	rm -rf debian/build
	rm -rf debian/tmp
	rm -f libmass/libmass.a
	rm -f libmassgui/libmassgui.a
	rm -f compile_commands.json
	rm -f doc/user-manual/DC-user-manual
	rm -f doc/user-manual/MineXpert3-doc.pdf

override_dh_auto_configure:
	mkdir -p debian/build
	mkdir -p debian/tmp
	cd debian/build && cmake -DCMAKE_BUILD_TYPE=Release -DBUILD_USER_MANUAL=1 -DCMAKE_INSTALL_PREFIX=/usr ../..

override_dh_auto_build:
	cd debian/build && make
	cd debian/build && make user-manual

override_dh_compress:
	dh_compress -X.pdf

override_dh_auto_install:
	cd debian/build && DESTDIR=../tmp make install
	dh_install

=== debian/watch ===
version=4

# The following page lists the releases
# https://gitlab.com/msxpertsuite/minexpert2/-/tags
# And the actual href in the page is
# href="/msxpertsuite/minexpert3/-/archive/8.1.1/minexpert3-8.1.1.tar.gz"

https://gitlab.com/msxpertsuite/minexpert3/-/tags \
    .*/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@

## minexpert3 11.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,7 +27,7 @@
 
 project(
     MineXpert3
-    VERSION 11.0.0
+    VERSION 11.1.0
     DESCRIPTION "A program to visualize and explore mass spectrometric data"
     HOMEPAGE_URL "http://wwww.msxpertsuite.org/minexpert3"
 )

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -145,9 +145,6 @@
     # The XIC chromatogram feature
     ${GUI_DIR}/XicExtractionWnd.cpp
     #
-    # Analysis preferences
-    ${GUI_DIR}/DiscoveriesPreferencesDlg.cpp
-    #
     # Plot overlay transparent widget and vertical rule slider
     ${GUI_DIR}/PlotAreaOverlay.cpp
     ${GUI_DIR}/VerticalRuleSlider.cpp
@@ -176,6 +173,8 @@
     ${GUI_DIR}/ui/ApplicationPreferencesWndDiscoveriesPageWidget.ui
     ${GUI_DIR}/ui/DecimalPlacesPreferencesWidget.ui
     ${GUI_DIR}/ui/MaxThreadCountPreferencesWidget.ui
+    ${GUI_DIR}/ui/PeakPickingPreferencesWidget.ui
+    ${GUI_DIR}/ui/LowMassDeconvolverPreferencesWidget.ui
 )
 
 set(CMAKE_AUTOUIC_SEARCH_PATHS ${GUI_DIR}/ui)

=== doc/user-manual/CMakeLists.txt ===
message("\n${BoldGreen}Configuring subdirectory doc/user-manual${ColourReset}\n")

message("")
message("\n${BoldYellow}Configuring the user manual compilation${ColourReset}\n")
message("")

# The file driving the user manual build is DC-user-manual.
# This file contains a config bit that points to the directory
# that contains de fop.xconf configuration file needed by
# the FOP utility that crafts the user manual pdf file.

set(FOP_XCONF_DIR ${CMAKE_SOURCE_DIR}/doc/user-manual)
configure_file(
    ${CMAKE_SOURCE_DIR}/CMakeStuff/DC-user-manual.cmake.in ${CMAKE_SOURCE_DIR}/doc/user-manual/DC-user-manual @ONLY
)

message("\tConfiguring the user manual compilation")

# The output of Daps will be in BUILD_DIR.
add_custom_target(
    user-manual ALL
    COMMAND make BUILD_DIR=${CMAKE_BINARY_DIR}/doc -f usermanual-makefile all_f
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/doc/user-manual
    COMMENT "Build of the DocBook-based user manual \
      documentation in ${CMAKE_BINARY_DIR}/doc"
)

set(DOC_STORE_PATH "${HOME_DEVEL_DIR}/msxpertsuite-store/docs/${LOWCASE_PROJECT_NAME_NO_VER}")

if(DEFINED ENV{DEB_BUILD_OPTIONS})

    message("Building debian package: not synchronizing documentation to doc store.")

else()

    # We want to store a local copy of the documentation so that we do not mess around
    # with build in unix that destroy the documentation if the build user manual switch
    # is not set and then MXE fails to find the doc pdf file.
    add_custom_command(
        TARGET user-manual
        POST_BUILD
        COMMAND rsync -avpP --delete ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}-doc.pdf ${CMAKE_CURRENT_BINARY_DIR}/html
                ${DOC_STORE_PATH}
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        COMMENT "Copy the documentation to ${DOC_STORE_PATH}"
    )

endif()


install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}-doc.pdf
    DESTINATION ${PROJECT_INSTALL_DOC_DIR}
)

install(
    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/user-manual/
    DESTINATION ${PROJECT_INSTALL_DOC_DIR}/html
)

message("")
message(STATUS "${BoldGreen}Finished configuring the ${CMAKE_PROJECT_NAME} user manual.${ColourReset}")
message("")

message("\n${BoldGreen}Done configuring subdirectory doc/user-manual${ColourReset}\n")

=== debian/changelog ===
minexpert3 (11.1.0-2) unstable; urgency=low

  * Fix dependencies on libpappsomspp and libxpertmass.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 21 Feb 2026 21:27:00 +0100

minexpert3 (11.1.0-1) unstable; urgency=low

  * New upstream release implementing a low mass deconvolution feature that
    is accessible from the mass spectrum composite plot widget menu.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 17 Feb 2026 16:48:16 +0100

minexpert3 (11.0.1-1) unstable; urgency=low

   * Bug fix release: now the vertical rule is plotted at the slider position
     with perfect calculation of the x-axis value of the rule position in the
     x-axis-locked plot widgets.

  -- Filippo Rusconi <lopippo@debian.org>  Tue, 13 Jan 2026 14:28:41 +0100

=== debian/control ===
--- 
+++ 
@@ -21,9 +21,9 @@
  fonts-ebgaramond-extra,
  fonts-urw-base35,
 # Only the logically essential one.
- libpappsomspp-gui-dev (>= 0.11.9),
+ libpappsomspp-gui-dev (>= 0.11.10),
 # Only the logically essential one.
- libxpertmassgui-dev (>= 1.7.1),
+ libxpertmassgui-dev (>= 1.8.1),
  libqscintilla2-qt6-dev,
  libisospec++-dev (>=2.3.1),
  libpwizlite-dev,
